<div>
  <h4>Uso di variabili per riferirsi ad elementi del template
    <small>senza usare alcun binding con il componente</small>
  </h4>
  <!--
    Lasciamo (blur)="update(box.value)" nonostante la funzione update
    sia stata implementata, in modo da far vedere la cattiveria con cui
    Angular ti informa della non corretta gestione/formattazione del codice
  -->
  <input class="form-control" #box
    (keyup)="0">
  <p>{{ box.value }}</p>
</div>
<hr>

<div>
  <h4>Uso di double binding e stato dell'elemento</h4>
  <input [(ngModel)]="valore" class="form-control" required>
  <p>{{ valore }}</p>
</div>
<hr>

<div>
  <h4>Uso di formControl</h4>
  <label>
    Name: <input type="text" class="form-control" [formControl]="name">
  </label>
  <p>{{ name.value }}</p>
</div>
<hr>

<div>
  <h4>Uso di formGroup</h4>
  <form [formGroup]="profileForm" (ngSubmit)="onSubmit()">

    <label>
      First Name: <input type="text" class="form-control" formControlName="firstName">
    </label>
    <br>
    <label>
      Last Name: <input type="text" class="form-control" formControlName="lastName">
    </label>
    <br>
    <button type="submit" class="btn btn-success mr-2" [disabled]="!profileForm.valid">Submit</button>
    <button type="button" class="btn btn-primary mr-2" (click)="setMyName()">Set my name</button>
    <button type="reset" class="btn btn-danger" (click)="resetForm()">Reset</button>
  </form>
</div>
